//+------------------------------------------------------------------+
//|                                                Stochastic-X8.mq5 | 
//|                                       Copyright  2010,   lukas1 | 
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, lukas1"
#property link ""
#property description "Stochastic-X8"
//----   
#property version   "1.00"
//----     
#property indicator_separate_window
//+-----------------------------------+
//|                 |
//+-----------------------------------+
#define LINES_TOTAL  8  //     
#define RESET        0  //        
//----   
#property indicator_buffers LINES_TOTAL 
//----   
#property indicator_plots   LINES_TOTAL
//+-----------------------------------+
//|      |
//+-----------------------------------+
//----     
#property indicator_type1   DRAW_LINE
//----   
#property indicator_color1  BlueViolet
//----  -  
#property indicator_style1 STYLE_SOLID
//----   1
#property indicator_width1  1
//+-----------------------------------+
//|         |
//+-----------------------------------+
//---- indicator parameters
input int Stoch_K=12;                              // K- ( )    %K
input int Stoch_D=8;                               //      %D
input int Stoch_S=5;                               //  
input double Koef=1.2;                             //   
input ENUM_MA_METHOD   ma_method=MODE_LWMA;        //  
input ENUM_STO_PRICE   price_field=STO_CLOSECLOSE; //   
//+-----------------------------------+
//----      
int Stoch_Handle[LINES_TOTAL];
//----      
int min_rates_total;
//+------------------------------------------------------------------+
//|                   |
//+------------------------------------------------------------------+  
class CIndicatorsBuffers
  {
public: double    IndBuffer[];
  };
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
CIndicatorsBuffers Ind[LINES_TOTAL];
//+------------------------------------------------------------------+   
//| Custom indicator initialization function                         | 
//+------------------------------------------------------------------+ 
void OnInit()
  {
//----     
   min_rates_total=int((Stoch_K+Stoch_D+Stoch_S)*MathPow(Koef,LINES_TOTAL-1));

//----
   for(int numb=0; numb<LINES_TOTAL; numb++)
     {
      double K=MathPow(Koef,numb);
      int period=int(Stoch_K*K);
      int Kperiod=int(Stoch_D*K);
      int Dperiod=int(Stoch_S*K);

      //----    iStochastic
      Stoch_Handle[numb]=iStochastic(NULL,0,period,Kperiod,Dperiod,ma_method,price_field);
      if(Stoch_Handle[numb]==INVALID_HANDLE)Print("      iStochastic ",numb);

      string shortname="";
      StringConcatenate(shortname,"Stochastic X",LINES_TOTAL,"*",DoubleToString(Koef,1),"(",period,Kperiod,Dperiod,")");
      //---           
      PlotIndexSetString(numb,PLOT_LABEL,shortname);
      //----   ,      
      PlotIndexSetDouble(numb,PLOT_EMPTY_VALUE,EMPTY_VALUE);
      //----      
      PlotIndexSetInteger(numb,PLOT_DRAW_BEGIN,min_rates_total);
      //----      
      SetIndexBuffer(numb,Ind[numb].IndBuffer,INDICATOR_DATA);
      //----    ,      
      ArraySetAsSeries(Ind[numb].IndBuffer,true);
      //----        
      PlotIndexSetInteger(numb,PLOT_DRAW_TYPE,PlotIndexGetInteger(0,PLOT_DRAW_TYPE));
      PlotIndexSetInteger(numb,PLOT_LINE_STYLE,PlotIndexGetInteger(0,PLOT_LINE_STYLE));
      PlotIndexSetInteger(numb,PLOT_LINE_WIDTH,PlotIndexGetInteger(0,PLOT_LINE_WIDTH));
      PlotIndexSetInteger(numb,PLOT_LINE_COLOR,PlotIndexGetInteger(0,PLOT_LINE_COLOR));
     }
//----      
   string shortname;
   StringConcatenate(shortname,"Stochastic X",LINES_TOTAL,"*",
                     DoubleToString(Koef,1),"(",EnumToString(ma_method),", ",EnumToString(price_field),")");
//----           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);

//----     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits+1);
//----  
  }
//+------------------------------------------------------------------+ 
//| Custom indicator iteration function                              | 
//+------------------------------------------------------------------+ 
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//----       
   if(rates_total<min_rates_total) return(0);
   for(int numb=0; numb<LINES_TOTAL; numb++) if(BarsCalculated(Stoch_Handle[numb])<min_rates_total) return(0);

//----    
   int to_copy;

//----     
   if(prev_calculated>rates_total || prev_calculated<=0) //      
      to_copy=rates_total-1;
   else to_copy=rates_total-prev_calculated+1;

//----       
   for(int numb=0; numb<LINES_TOTAL; numb++) if(CopyBuffer(Stoch_Handle[numb],0,0,to_copy,Ind[numb].IndBuffer)<=0) return(0);
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
